summaryrefslogtreecommitdiffstats
path: root/external-schema-repo-generator/install.sh
diff options
context:
space:
mode:
authorMichal Banka <michal.banka@nokia.com>2020-10-28 12:01:03 +0100
committerMichal Banka <michal.banka@nokia.com>2020-10-28 12:01:11 +0100
commita111aa071b81aaaed46e6dbc105a248152cd9ed4 (patch)
tree122db1babde659f3fffc6bdaf6754894584f935a /external-schema-repo-generator/install.sh
parent2e73d9c6088ad2d6a34915e6e5daec0ac67e8d22 (diff)
[UTILS] Add new external-schema-repo-generator tool
Added script tool which generates and installs ConfigMap containing schemas used for event validation. Main purpose of this script is mounting custom schemas to DCAE VES Collector, yet it might be used in any component. Signed-off-by: Michal Banka <michal.banka@nokia.com> Issue-ID: OOM-2589 Change-Id: Ia82638186d42ba614636b0c258c50e313782da58
Diffstat (limited to 'external-schema-repo-generator/install.sh')
-rwxr-xr-xexternal-schema-repo-generator/install.sh58
1 files changed, 58 insertions, 0 deletions
diff --git a/external-schema-repo-generator/install.sh b/external-schema-repo-generator/install.sh
new file mode 100755
index 0000000..2f926b6
--- /dev/null
+++ b/external-schema-repo-generator/install.sh
@@ -0,0 +1,58 @@
+#!/bin/sh
+
+# ============LICENSE_START=======================================================
+# OOM
+# ================================================================================
+# Copyright (C) 2020 Nokia. All rights reserved.
+# ================================================================================
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+# http://www.apache.org/licenses/LICENSE-2.0
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+# ============LICENSE_END=========================================================
+
+# Arguments renaming
+spec_configmap_filename=$1
+k8s_configmap_name=$2
+
+# Constants
+MAX_SPEC_SIZE=262144
+
+# Alias
+alias kubectl_onap="kubectl -n onap"
+
+# Checks whether ConfigMap $spec_configmap_filename exists
+# When file does not exist exits with return code 1
+checkIfSpecExists() {
+ if [ ! -f "$spec_configmap_filename" ]; then
+ echo "Spec file $spec_configmap_filename does not exist."
+ # todo add location of spec with filename
+ exit 1
+ fi
+}
+
+# Uploads ConfigMap spec $spec_configmap_filename to Kubernetes
+uploadConfigMap() {
+ spec_size=$(stat --printf="%s" "$spec_configmap_filename")
+ if [ "$spec_size" -ge $MAX_SPEC_SIZE ]; then
+ echo "ConfigMap spec file is too long for 'kubectl apply'. Actual spec length: $spec_size, max spec length: $MAX_SPEC_SIZE"
+ echo "Creating new ConfigMap $k8s_configmap_name"
+ kubectl_onap create -f "$spec_configmap_filename"
+ else
+ echo "Applying ConfigMap $k8s_configmap_name"
+ kubectl_onap apply -f "$spec_configmap_filename"
+ fi
+}
+
+main() {
+ checkIfSpecExists
+ uploadConfigMap
+}
+
+main
+